My Project: openb3dlib.mod/openb3d/src/functions.cpp File Reference

My Project

Functions
functions.cpp File Reference
`#include "texture.h"`
`#include "entity.h"`
`#include "mesh.h"`
`#include "global.h"`
`#include "camera.h"`
`#include "pick.h"`
`#include "light.h"`
`#include "shadow.h"`
`#include "stencil.h"`
`#include "csg.h"`
`#include "voxel.h"`
`#include "octree.h"`
`#include "geosphere.h"`
`#include "isosurface.h"`
`#include "particle.h"`
`#include "physics.h"`
`#include "actions.h"`

## Functions

void | FreeShader (Shader *shader)
void | FreeStencil (Stencil *stencil)
void | TextureFlags (Texture *tex, int flags)
void | FreeSurface (Surface *surf)
void | TextureGLTexEnv (Texture *tex, int target, int pname, int param)
void | BrushGLColor (Brush *brush, float r, float g, float b, float a)
void | BrushGLBlendFunc (Brush *brush, int sfactor, int dfactor)
void | BufferToTex (Texture *tex, unsigned char *buffer, int frame)
void | BackBufferToTex (Texture *tex, int frame)
void | CameraToTex (Texture *tex, Camera *cam, int frame)
void | TexToBuffer (Texture *tex, unsigned char *buffer, int frame)
void | MeshCullRadius (Entity *ent, float radius)
int | AddAnimSeq (Entity *ent, int length)
void | AddMesh (Mesh *mesh1, Mesh *mesh2)
int | AddTriangle (Surface *surf, int v0, int v1, int v2)
int | AddVertex (Surface *surf, float x, float y, float z, float u, float v, float w)
void | AmbientLight (float r, float g, float b)
void | AntiAlias (int samples)
void | Animate (Entity *ent, int mode, float speed, int seq, int trans)
int | Animating (Entity *ent)
int | AnimLength (Entity *ent)
int | AnimSeq (Entity *ent)
float | AnimTime (Entity *ent)
void | BrushAlpha (Brush *brush, float a)
void | BrushBlend (Brush *brush, int blend)
void | BrushColor (Brush *brush, float r, float g, float b)
void | BrushFX (Brush *brush, int fx)
void | BrushShininess (Brush *brush, float s)
void | BrushTexture (Brush *brush, Texture *tex, int frame, int index)
void | CameraClsColor (Camera *cam, float r, float g, float b)
void | CameraClsMode (Camera *cam, int cls_depth, int cls_zbuffer)
void | CameraFogColor (Camera *cam, float r, float g, float b)
void | CameraFogMode (Camera *cam, int mode)
void | CameraFogRange (Camera *cam, float nnear, float nfar)
Entity * | CameraPick (Camera *cam, float x, float y)
void | CameraProject (Camera *cam, float x, float y, float z)
void | CameraProjMode (Camera *cam, int mode)
void | CameraRange (Camera *cam, float nnear, float nfar)
void | CameraViewport (Camera *cam, int x, int y, int width, int height)
void | CameraZoom (Camera *cam, float zoom)
void | ClearCollisions ()
void | ClearSurface (Surface *surf, bool clear_verts, bool clear_tris)
void | ClearTextureFilters ()
void | ClearWorld (bool entities, bool brushes, bool textures)
Entity * | CollisionEntity (Entity *ent, int index)
void | Collisions (int src_no, int dest_no, int method_no, int response_no)
float | CollisionNX (Entity *ent, int index)
float | CollisionNY (Entity *ent, int index)
float | CollisionNZ (Entity *ent, int index)
Surface * | CollisionSurface (Entity *ent, int index)
float | CollisionTime (Entity *ent, int index)
int | CollisionTriangle (Entity *ent, int index)
float | CollisionX (Entity *ent, int index)
float | CollisionY (Entity *ent, int index)
float | CollisionZ (Entity *ent, int index)
int | CountChildren (Entity *ent)
int | CountCollisions (Entity *ent)
Entity * | CopyEntity (Entity *ent, Entity *parent)
Mesh * | CopyMesh (Mesh *mesh, Entity *parent)
int | CountSurfaces (Mesh *mesh)
int | CountTriangles (Surface *surf)
int | CountVertices (Surface *surf)
Blob * | CreateBlob (Fluid *fluid, float radius, Entity *parent_ent)
Bone * | CreateBone (Mesh *mesh, Entity *parent_ent)
Brush * | CreateBrush (float r, float g, float b)
Camera * | CreateCamera (Entity *parent)
Constraint * | CreateConstraint (Entity *p1, Entity *p2, float l)
Mesh * | CreateCone (int segments, bool solid, Entity *parent)
Mesh * | CreateCylinder (int segments, bool solid, Entity *parent)
Mesh * | CreateCube (Entity *parent)
Terrain * | CreateGeosphere (int size, Entity *parent)
Mesh * | CreateMesh (Entity *parent)
Light * | CreateLight (int light_type, Entity *parent)
Pivot * | CreatePivot (Entity *parent)
Mesh * | CreatePlane (int divisions, Entity *parent)
Mesh * | CreateQuad (Entity *parent)
RigidBody * | CreateRigidBody (Entity *body, Entity *p1, Entity *p2, Entity *p3, Entity *p4)
ShadowObject * | CreateShadow (Mesh *parent, char Static)
Mesh * | CreateSphere (int segments, Entity *parent)
Sprite * | CreateSprite (Entity *parent)
Surface * | CreateSurface (Mesh *mesh, Brush *brush)
Stencil * | CreateStencil ()
Terrain * | CreateTerrain (int size, Entity *parent)
Texture * | CreateTexture (int width, int height, int flags, int frames)
VoxelSprite * | CreateVoxelSprite (int slices, Entity *parent)
float | DeltaPitch (Entity *ent1, Entity *ent2)
float | DeltaYaw (Entity *ent1, Entity *ent2)
void | EmitterVector (ParticleEmitter *emit, float x, float y, float z)
void | EmitterRate (ParticleEmitter *emit, float r)
void | EmitterParticleLife (ParticleEmitter *emit, int l)
void | EmitterParticleFunction (ParticleEmitter *emit, void(*EmitterFunction)(Entity *, int))
void | EmitterParticleSpeed (ParticleEmitter *emit, float s)
void | EmitterVariance (ParticleEmitter *emit, float v)
void | EntityAlpha (Entity *ent, float alpha)
void | EntityAutoFade (Entity *ent, float near, float far)
void | EntityBlend (Entity *ent, int blend)
void | EntityBox (Entity *ent, float x, float y, float z, float w, float h, float d)
const char * | EntityClass (Entity *ent)
Entity * | EntityCollided (Entity *ent, int type_no)
void | EntityColor (Entity *ent, float red, float green, float blue)
float | EntityDistance (Entity *ent1, Entity *ent2)
void | EntityFX (Entity *ent, int fx)
int | EntityInView (Entity *ent, Camera *cam)
const char * | EntityName (Entity *ent)
void | EntityOrder (Entity *ent, int order)
void | EntityParent (Entity *ent, Entity *parent_ent, bool glob)
Entity * | EntityPick (Entity *ent, float range)
void | EntityPickMode (Entity *ent, int pick_mode, bool obscurer)
float | EntityPitch (Entity *ent, bool glob)
void | EntityRadius (Entity *ent, float radius_x, float radius_y)
float | EntityRoll (Entity *ent, bool glob)
void | EntityShininess (Entity *ent, float shine)
void | EntityTexture (Entity *ent, Texture *tex, int frame, int index)
void | EntityType (Entity *ent, int type_no, bool recursive)
int | EntityVisible (Entity *src_ent, Entity *dest_ent)
float | EntityX (Entity *ent, bool glob)
float | EntityY (Entity *ent, bool glob)
float | EntityYaw (Entity *ent, bool glob)
float | EntityZ (Entity *ent, bool glob)
int | ExtractAnimSeq (Entity *ent, int first_frame, int last_frame, int seq)
Entity * | FindChild (Entity *ent, char *child_name)
Surface * | FindSurface (Mesh *mesh, Brush *brush)
void | FitMesh (Mesh *mesh, float x, float y, float z, float width, float height, float depth, bool uniform)
void | FlipMesh (Mesh *mesh)
void | FluidArray (Fluid *fluid, float *Array, int w, int h, int d)
void | FluidFunction (Fluid *fluid, float(*FieldFunction)(float, float, float))
void | FluidThreshold (Fluid *fluid, float threshold)
void | FreeBrush (Brush *brush)
void | FreeConstraint (Constraint *con)
void | FreeEntity (Entity *ent)
void | FreeRigidBody (RigidBody *body)
void | FreeShadow (ShadowObject *shad)
void | FreeTexture (Texture *tex)
void | GeosphereHeight (Geosphere *geo, float h)
Texture * | GetBrushTexture (Brush *brush, int index)
Entity * | GetChild (Entity *ent, int child_no)
Brush * | GetEntityBrush (Entity *ent)
int | GetEntityType (Entity *ent)
float | GetMatElement (Entity *ent, int row, int col)
Entity * | GetParentEntity (Entity *ent)
Surface * | GetSurface (Mesh *mesh, int surf_no)
Brush * | GetSurfaceBrush (Surface *surf)
void | Graphics3D (int width, int height, int depth, int mode, int rate)
void | HandleSprite (Sprite *sprite, float h_x, float h_y)
void | HideEntity (Entity *ent)
void | LightColor (Light *light, float red, float green, float blue)
void | LightConeAngles (Light *light, float inner_ang, float outer_ang)
void | LightRange (Light *light, float range)
Entity * | LinePick (float x, float y, float z, float dx, float dy, float dz, float radius)
Mesh * | LoadAnimMesh (char *file, Entity *parent)
int | LoadAnimSeq (Entity *ent, char *file)
Texture * | LoadAnimTexture (char *file, int flags, int frame_width, int frame_height, int first_frame, int frame_count)
Brush * | LoadBrush (char *file, int flags, float u_scale, float v_scale)
Terrain * | LoadGeosphere (char *file, Entity *parent)
Mesh * | LoadMesh (char *file, Entity *parent)
Terrain * | LoadTerrain (char *file, Entity *parent)
Texture * | LoadTexture (char *file, int flags)
Sprite * | LoadSprite (char *tex_file, int tex_flag, Entity *parent)
Mesh * | MeshCSG (Mesh *m1, Mesh *m2, int method=1)
float | MeshDepth (Mesh *mesh)
int | MeshesIntersect (Mesh *mesh1, Mesh *mesh2)
float | MeshHeight (Mesh *mesh)
float | MeshWidth (Mesh *mesh)
void | ModifyGeosphere (Geosphere *geo, int x, int z, float new_height)
void | ModifyTerrain (Terrain *terr, int x, int z, float new_height)
void | MoveEntity (Entity *ent, float x, float y, float z)
void | NameEntity (Entity *ent, char *name)
void | PaintEntity (Entity *ent, Brush *brush)
void | PaintMesh (Mesh *mesh, Brush *brush)
void | PaintSurface (Surface *surf, Brush *brush)
void | ParticleColor (Sprite *sprite, float r, float g, float b, float a)
void | ParticleVector (Sprite *sprite, float x, float y, float z)
void | ParticleTrail (Sprite *sprite, int length)
Entity * | PickedEntity ()
float | PickedNX ()
float | PickedNY ()
float | PickedNZ ()
Surface * | PickedSurface ()
float | PickedTime ()
int | PickedTriangle ()
float | PickedX ()
float | PickedY ()
float | PickedZ ()
void | PointEntity (Entity *ent, Entity *target_ent, float roll)
void | PositionEntity (Entity *ent, float x, float y, float z, bool glob)
void | PositionMesh (Mesh *mesh, float px, float py, float pz)
void | PositionTexture (Texture *tex, float u_pos, float v_pos)
float | ProjectedX ()
float | ProjectedY ()
float | ProjectedZ ()
void | RenderWorld ()
Mesh * | RepeatMesh (Mesh *mesh, Entity *parent)
void | ResetEntity (Entity *ent)
void | ResetShadow (ShadowObject *shad)
void | RotateEntity (Entity *ent, float x, float y, float z, bool glob)
void | RotateMesh (Mesh *mesh, float pitch, float yaw, float roll)
void | RotateSprite (Sprite *sprite, float ang)
void | RotateTexture (Texture *tex, float ang)
void | ScaleEntity (Entity *ent, float x, float y, float z, bool glob)
void | ScaleMesh (Mesh *mesh, float sx, float sy, float sz)
void | ScaleSprite (Sprite *sprite, float s_x, float s_y)
void | ScaleTexture (Texture *tex, float u_scale, float v_scale)
void | SetAnimKey (Entity *ent, float frame, int pos_key=true, int rot_key=true, int scale_key=true)
void | SetAnimTime (Entity *ent, float time, int seq)
void | SetCubeFace (Texture *tex, int face)
void | SetCubeMode (Texture *tex, int mode)
void | ShowEntity (Entity *ent)
void | SkinMesh (Mesh *mesh, int surf_no_get, int vid, int bone1, float weight1=1.0, int bone2=0, float weight2=0, int bone3=0, float weight3=0, int bone4=0, float weight4=0)
void | SpriteRenderMode (Sprite *sprite, int mode)
void | SpriteViewMode (Sprite *sprite, int mode)
void | StencilAlpha (Stencil *stencil, float a)
void | StencilClsColor (Stencil *stencil, float r, float g, float b)
void | StencilClsMode (Stencil *stencil, int cls_depth, int cls_zbuffer)
void | StencilMesh (Stencil *stencil, Mesh *mesh, int mode=1)
void | StencilMode (Stencil *stencil, int m, int o=1)
float | TerrainHeight (Terrain *terr, int x, int z)
float | TerrainX (Terrain *terr, float x, float y, float z)
float | TerrainY (Terrain *terr, float x, float y, float z)
float | TerrainZ (Terrain *terr, float x, float y, float z)
void | TextureBlend (Texture *tex, int blend)
void | TextureCoords (Texture *tex, int coords)
int | TextureHeight (Texture *tex)
void | TextureFilter (char *match_text, int flags)
const char * | TextureName (Texture *tex)
int | TextureWidth (Texture *tex)
float | TFormedX ()
float | TFormedY ()
float | TFormedZ ()
void | TFormNormal (float x, float y, float z, Entity *src_ent, Entity *dest_ent)
void | TFormPoint (float x, float y, float z, Entity *src_ent, Entity *dest_ent)
void | TFormVector (float x, float y, float z, Entity *src_ent, Entity *dest_ent)
void | TranslateEntity (Entity *ent, float x, float y, float z, bool glob)
int | TriangleVertex (Surface *surf, int tri_no, int corner)
void | TurnEntity (Entity *ent, float x, float y, float z, bool glob)
void | UpdateNormals (Mesh *mesh)
void | UpdateTexCoords (Surface *surf)
void | UpdateWorld (float anim_speed)
void | UseStencil (Stencil *stencil)
float | VectorPitch (float vx, float vy, float vz)
float | VectorYaw (float vx, float vy, float vz)
float | VertexAlpha (Surface *surf, int vid)
float | VertexBlue (Surface *surf, int vid)
void | VertexColor (Surface *surf, int vid, float r, float g, float b, float a)
void | VertexCoords (Surface *surf, int vid, float x, float y, float z)
float | VertexGreen (Surface *surf, int vid)
void | VertexNormal (Surface *surf, int vid, float nx, float ny, float nz)
float | VertexNX (Surface *surf, int vid)
float | VertexNY (Surface *surf, int vid)
float | VertexNZ (Surface *surf, int vid)
float | VertexRed (Surface *surf, int vid)
void | VertexTexCoords (Surface *surf, int vid, float u, float v, float w, int coord_set)
float | VertexU (Surface *surf, int vid, int coord_set)
float | VertexV (Surface *surf, int vid, int coord_set)
float | VertexW (Surface *surf, int vid, int coord_set)
float | VertexX (Surface *surf, int vid)
float | VertexY (Surface *surf, int vid)
float | VertexZ (Surface *surf, int vid)
void | VoxelSpriteMaterial (VoxelSprite *voxelspr, Material *mat)
void | Wireframe (int enable)
float | EntityScaleX (Entity *ent, bool glob)
float | EntityScaleY (Entity *ent, bool glob)
float | EntityScaleZ (Entity *ent, bool glob)
Shader * | LoadShader (char *ShaderName, char *VshaderFileName, char *FshaderFileName)
Shader * | CreateShader (char *ShaderName, char *VshaderString, char *FshaderString)
void | ShadeSurface (Surface *surf, Shader *material)
void | ShadeMesh (Mesh *mesh, Shader *material)
void | ShadeEntity (Entity *ent, Shader *material)
Texture * | ShaderTexture (Shader *material, Texture *tex, char *name, int index)
void | SetFloat (Shader *material, char *name, float v1)
void | SetFloat2 (Shader *material, char *name, float v1, float v2)
void | SetFloat3 (Shader *material, char *name, float v1, float v2, float v3)
void | SetFloat4 (Shader *material, char *name, float v1, float v2, float v3, float v4)
void | UseFloat (Shader *material, char *name, float *v1)
void | UseFloat2 (Shader *material, char *name, float *v1, float *v2)
void | UseFloat3 (Shader *material, char *name, float *v1, float *v2, float *v3)
void | UseFloat4 (Shader *material, char *name, float *v1, float *v2, float *v3, float *v4)
void | SetInteger (Shader *material, char *name, int v1)
void | SetInteger2 (Shader *material, char *name, int v1, int v2)
void | SetInteger3 (Shader *material, char *name, int v1, int v2, int v3)
void | SetInteger4 (Shader *material, char *name, int v1, int v2, int v3, int v4)
void | UseInteger (Shader *material, char *name, int *v1)
void | UseInteger2 (Shader *material, char *name, int *v1, int *v2)
void | UseInteger3 (Shader *material, char *name, int *v1, int *v2, int *v3)
void | UseInteger4 (Shader *material, char *name, int *v1, int *v2, int *v3, int *v4)
void | UseSurface (Shader *material, char *name, Surface *surf, int vbo)
void | UseMatrix (Shader *material, char *name, int mode)
Material * | LoadMaterial (char *filename, int flags, int frame_width, int frame_height, int first_frame, int frame_count)
void | ShaderMaterial (Shader *material, Material *tex, char *name, int index)
void | AmbientShader (Shader *material)
OcTree * | CreateOcTree (float w, float h, float d, Entity *parent_ent=0)
void | OctreeBlock (OcTree *octree, Mesh *mesh, int level, float X, float Y, float Z, float Near=0.0, float Far=1000.0)
void | OctreeMesh (OcTree *octree, Mesh *mesh, int level, float X, float Y, float Z, float Near=0.0, float Far=1000.0)
Fluid * | CreateFluid ()
ParticleEmitter * | CreateParticleEmitter (Entity *particle, Entity *parent_ent=0)
Action * | ActMoveBy (Entity *ent, float a, float b, float c, float rate)
Action * | ActTurnBy (Entity *ent, float a, float b, float c, float rate)
Action * | ActVector (Entity *ent, float a, float b, float c)
Action * | ActMoveTo (Entity *ent, float a, float b, float c, float rate)
Action * | ActTurnTo (Entity *ent, float a, float b, float c, float rate)
Action * | ActScaleTo (Entity *ent, float a, float b, float c, float rate)
Action * | ActFadeTo (Entity *ent, float a, float rate)
Action * | ActTintTo (Entity *ent, float a, float b, float c, float rate)
Action * | ActTrackByPoint (Entity *ent, Entity *target, float a, float b, float c, float rate)
Action * | ActTrackByDistance (Entity *ent, Entity *target, float a, float rate)
Action * | ActNewtonian (Entity *ent, float rate)
void | AppendAction (Action *act1, Action *act2)
void | FreeAction (Action *act)
void | DepthBufferToTex (Texture *tex, Camera *cam=0)

## Function Documentation

## § ActFadeTo()

Action* ActFadeTo | ( | Entity * | ent,
|  | float | a,
|  | float | rate
| ) |  |

## § ActMoveBy()

Action* ActMoveBy | ( | Entity * | ent,
|  | float | a,
|  | float | b,
|  | float | c,
|  | float | rate
| ) |  |

## § ActMoveTo()

Action* ActMoveTo | ( | Entity * | ent,
|  | float | a,
|  | float | b,
|  | float | c,
|  | float | rate
| ) |  |

## § ActNewtonian()

Action* ActNewtonian | ( | Entity * | ent,
|  | float | rate
| ) |  |

## § ActScaleTo()

Action* ActScaleTo | ( | Entity * | ent,
|  | float | a,
|  | float | b,
|  | float | c,
|  | float | rate
| ) |  |

## § ActTintTo()

Action* ActTintTo | ( | Entity * | ent,
|  | float | a,
|  | float | b,
|  | float | c,
|  | float | rate
| ) |  |

## § ActTrackByDistance()

Action* ActTrackByDistance | ( | Entity * | ent,
|  | Entity * | target,
|  | float | a,
|  | float | rate
| ) |  |

## § ActTrackByPoint()

Action* ActTrackByPoint | ( | Entity * | ent,
|  | Entity * | target,
|  | float | a,
|  | float | b,
|  | float | c,
|  | float | rate
| ) |  |

## § ActTurnBy()

Action* ActTurnBy | ( | Entity * | ent,
|  | float | a,
|  | float | b,
|  | float | c,
|  | float | rate
| ) |  |

## § ActTurnTo()

Action* ActTurnTo | ( | Entity * | ent,
|  | float | a,
|  | float | b,
|  | float | c,
|  | float | rate
| ) |  |

## § ActVector()

Action* ActVector | ( | Entity * | ent,
|  | float | a,
|  | float | b,
|  | float | c
| ) |  |

## § AddAnimSeq()

int AddAnimSeq | ( | Entity * | ent,
|  | int | length
| ) |  |

## § AddMesh()

void AddMesh | ( | Mesh * | mesh1,
|  | Mesh * | mesh2
| ) |  |

## § AddTriangle()

int AddTriangle | ( | Surface * | surf,
|  | int | v0,
|  | int | v1,
|  | int | v2
| ) |  |

## § AddVertex()

int AddVertex | ( | Surface * | surf,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | u,
|  | float | v,
|  | float | w
| ) |  |

## § AmbientLight()

void AmbientLight | ( | float | r,
|  | float | g,
|  | float | b
| ) |  |

## § AmbientShader()

void AmbientShader | ( | Shader * | material | ) |

## § Animate()

void Animate | ( | Entity * | ent,
|  | int | mode,
|  | float | speed,
|  | int | seq,
|  | int | trans
| ) |  |

## § Animating()

int Animating | ( | Entity * | ent | ) |

## § AnimLength()

int AnimLength | ( | Entity * | ent | ) |

## § AnimSeq()

int AnimSeq | ( | Entity * | ent | ) |

## § AnimTime()

float AnimTime | ( | Entity * | ent | ) |

## § AntiAlias()

void AntiAlias | ( | int | samples | ) |

## § AppendAction()

void AppendAction | ( | Action * | act1,
|  | Action * | act2
| ) |  |

## § BackBufferToTex()

void BackBufferToTex | ( | Texture * | tex,
|  | int | frame
| ) |  |

## § BrushAlpha()

void BrushAlpha | ( | Brush * | brush,
|  | float | a
| ) |  |

## § BrushBlend()

void BrushBlend | ( | Brush * | brush,
|  | int | blend
| ) |  |

## § BrushColor()

void BrushColor | ( | Brush * | brush,
|  | float | r,
|  | float | g,
|  | float | b
| ) |  |

## § BrushFX()

void BrushFX | ( | Brush * | brush,
|  | int | fx
| ) |  |

## § BrushGLBlendFunc()

void BrushGLBlendFunc | ( | Brush * | brush,
|  | int | sfactor,
|  | int | dfactor
| ) |  |

## § BrushGLColor()

void BrushGLColor | ( | Brush * | brush,
|  | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |

## § BrushShininess()

void BrushShininess | ( | Brush * | brush,
|  | float | s
| ) |  |

## § BrushTexture()

void BrushTexture | ( | Brush * | brush,
|  | Texture * | tex,
|  | int | frame,
|  | int | index
| ) |  |

## § BufferToTex()

void BufferToTex | ( | Texture * | tex,
|  | unsigned char * | buffer,
|  | int | frame
| ) |  |

## § CameraClsColor()

void CameraClsColor | ( | Camera * | cam,
|  | float | r,
|  | float | g,
|  | float | b
| ) |  |

## § CameraClsMode()

void CameraClsMode | ( | Camera * | cam,
|  | int | cls_depth,
|  | int | cls_zbuffer
| ) |  |

## § CameraFogColor()

void CameraFogColor | ( | Camera * | cam,
|  | float | r,
|  | float | g,
|  | float | b
| ) |  |

## § CameraFogMode()

void CameraFogMode | ( | Camera * | cam,
|  | int | mode
| ) |  |

## § CameraFogRange()

void CameraFogRange | ( | Camera * | cam,
|  | float | nnear,
|  | float | nfar
| ) |  |

## § CameraPick()

Entity* CameraPick | ( | Camera * | cam,
|  | float | x,
|  | float | y
| ) |  |

## § CameraProject()

void CameraProject | ( | Camera * | cam,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § CameraProjMode()

void CameraProjMode | ( | Camera * | cam,
|  | int | mode
| ) |  |

## § CameraRange()

void CameraRange | ( | Camera * | cam,
|  | float | nnear,
|  | float | nfar
| ) |  |

## § CameraToTex()

void CameraToTex | ( | Texture * | tex,
|  | Camera * | cam,
|  | int | frame
| ) |  |

## § CameraViewport()

void CameraViewport | ( | Camera * | cam,
|  | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

## § CameraZoom()

void CameraZoom | ( | Camera * | cam,
|  | float | zoom
| ) |  |

## § ClearCollisions()

void ClearCollisions | ( |  | ) |

## § ClearSurface()

void ClearSurface | ( | Surface * | surf,
|  | bool | clear_verts,
|  | bool | clear_tris
| ) |  |

## § ClearTextureFilters()

void ClearTextureFilters | ( |  | ) |

## § ClearWorld()

void ClearWorld | ( | bool | entities,
|  | bool | brushes,
|  | bool | textures
| ) |  |

## § CollisionEntity()

Entity* CollisionEntity | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionNX()

float CollisionNX | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionNY()

float CollisionNY | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionNZ()

float CollisionNZ | ( | Entity * | ent,
|  | int | index
| ) |  |

## § Collisions()

void Collisions | ( | int | src_no,
|  | int | dest_no,
|  | int | method_no,
|  | int | response_no
| ) |  |

## § CollisionSurface()

Surface* CollisionSurface | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionTime()

float CollisionTime | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionTriangle()

int CollisionTriangle | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionX()

float CollisionX | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionY()

float CollisionY | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CollisionZ()

float CollisionZ | ( | Entity * | ent,
|  | int | index
| ) |  |

## § CopyEntity()

Entity* CopyEntity | ( | Entity * | ent,
|  | Entity * | parent
| ) |  |

## § CopyMesh()

Mesh* CopyMesh | ( | Mesh * | mesh,
|  | Entity * | parent
| ) |  |

## § CountChildren()

int CountChildren | ( | Entity * | ent | ) |

## § CountCollisions()

int CountCollisions | ( | Entity * | ent | ) |

## § CountSurfaces()

int CountSurfaces | ( | Mesh * | mesh | ) |

## § CountTriangles()

int CountTriangles | ( | Surface * | surf | ) |

## § CountVertices()

int CountVertices | ( | Surface * | surf | ) |

## § CreateBlob()

Blob* CreateBlob | ( | Fluid * | fluid,
|  | float | radius,
|  | Entity * | parent_ent
| ) |  |

## § CreateBone()

Bone* CreateBone | ( | Mesh * | mesh,
|  | Entity * | parent_ent
| ) |  |

## § CreateBrush()

Brush* CreateBrush | ( | float | r,
|  | float | g,
|  | float | b
| ) |  |

## § CreateCamera()

Camera* CreateCamera | ( | Entity * | parent | ) |

## § CreateCone()

Mesh* CreateCone | ( | int | segments,
|  | bool | solid,
|  | Entity * | parent
| ) |  |

## § CreateConstraint()

Constraint* CreateConstraint | ( | Entity * | p1,
|  | Entity * | p2,
|  | float | l
| ) |  |

## § CreateCube()

Mesh* CreateCube | ( | Entity * | parent | ) |

## § CreateCylinder()

Mesh* CreateCylinder | ( | int | segments,
|  | bool | solid,
|  | Entity * | parent
| ) |  |

## § CreateFluid()

Fluid* CreateFluid | ( |  | ) |

## § CreateGeosphere()

Terrain* CreateGeosphere | ( | int | size,
|  | Entity * | parent
| ) |  |

## § CreateLight()

Light* CreateLight | ( | int | light_type,
|  | Entity * | parent
| ) |  |

## § CreateMesh()

Mesh* CreateMesh | ( | Entity * | parent | ) |

## § CreateOcTree()

OcTree* CreateOcTree | ( | float | w,
|  | float | h,
|  | float | d,
|  | Entity * | parent_ent = `0`
| ) |  |

## § CreateParticleEmitter()

ParticleEmitter* CreateParticleEmitter | ( | Entity * | particle,
|  | Entity * | parent_ent = `0`
| ) |  |

## § CreatePivot()

Pivot* CreatePivot | ( | Entity * | parent | ) |

## § CreatePlane()

Mesh* CreatePlane | ( | int | divisions,
|  | Entity * | parent
| ) |  |

## § CreateQuad()

Mesh* CreateQuad | ( | Entity * | parent | ) |

## § CreateRigidBody()

RigidBody* CreateRigidBody | ( | Entity * | body,
|  | Entity * | p1,
|  | Entity * | p2,
|  | Entity * | p3,
|  | Entity * | p4
| ) |  |

## § CreateShader()

Shader* CreateShader | ( | char * | ShaderName,
|  | char * | VshaderString,
|  | char * | FshaderString
| ) |  |

## § CreateShadow()

ShadowObject* CreateShadow | ( | Mesh * | parent,
|  | char | Static
| ) |  |

## § CreateSphere()

Mesh* CreateSphere | ( | int | segments,
|  | Entity * | parent
| ) |  |

## § CreateSprite()

Sprite* CreateSprite | ( | Entity * | parent | ) |

## § CreateStencil()

Stencil* CreateStencil | ( |  | ) |

## § CreateSurface()

Surface* CreateSurface | ( | Mesh * | mesh,
|  | Brush * | brush
| ) |  |

## § CreateTerrain()

Terrain* CreateTerrain | ( | int | size,
|  | Entity * | parent
| ) |  |

## § CreateTexture()

Texture* CreateTexture | ( | int | width,
|  | int | height,
|  | int | flags,
|  | int | frames
| ) |  |

## § CreateVoxelSprite()

VoxelSprite* CreateVoxelSprite | ( | int | slices,
|  | Entity * | parent
| ) |  |

## § DeltaPitch()

float DeltaPitch | ( | Entity * | ent1,
|  | Entity * | ent2
| ) |  |

## § DeltaYaw()

float DeltaYaw | ( | Entity * | ent1,
|  | Entity * | ent2
| ) |  |

## § DepthBufferToTex()

void DepthBufferToTex | ( | Texture * | tex,
|  | Camera * | cam = `0`
| ) |  |

## § EmitterParticleFunction()

void EmitterParticleFunction | ( | ParticleEmitter * | emit,
|  | void(*)(Entity *, int) | EmitterFunction
| ) |  |

## § EmitterParticleLife()

void EmitterParticleLife | ( | ParticleEmitter * | emit,
|  | int | l
| ) |  |

## § EmitterParticleSpeed()

void EmitterParticleSpeed | ( | ParticleEmitter * | emit,
|  | float | s
| ) |  |

## § EmitterRate()

void EmitterRate | ( | ParticleEmitter * | emit,
|  | float | r
| ) |  |

## § EmitterVariance()

void EmitterVariance | ( | ParticleEmitter * | emit,
|  | float | v
| ) |  |

## § EmitterVector()

void EmitterVector | ( | ParticleEmitter * | emit,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § EntityAlpha()

void EntityAlpha | ( | Entity * | ent,
|  | float | alpha
| ) |  |

## § EntityAutoFade()

void EntityAutoFade | ( | Entity * | ent,
|  | float | near,
|  | float | far
| ) |  |

## § EntityBlend()

void EntityBlend | ( | Entity * | ent,
|  | int | blend
| ) |  |

## § EntityBox()

void EntityBox | ( | Entity * | ent,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | w,
|  | float | h,
|  | float | d
| ) |  |

## § EntityClass()

const char* EntityClass | ( | Entity * | ent | ) |

## § EntityCollided()

Entity* EntityCollided | ( | Entity * | ent,
|  | int | type_no
| ) |  |

## § EntityColor()

void EntityColor | ( | Entity * | ent,
|  | float | red,
|  | float | green,
|  | float | blue
| ) |  |

## § EntityDistance()

float EntityDistance | ( | Entity * | ent1,
|  | Entity * | ent2
| ) |  |

## § EntityFX()

void EntityFX | ( | Entity * | ent,
|  | int | fx
| ) |  |

## § EntityInView()

int EntityInView | ( | Entity * | ent,
|  | Camera * | cam
| ) |  |

## § EntityName()

const char* EntityName | ( | Entity * | ent | ) |

## § EntityOrder()

void EntityOrder | ( | Entity * | ent,
|  | int | order
| ) |  |

## § EntityParent()

void EntityParent | ( | Entity * | ent,
|  | Entity * | parent_ent,
|  | bool | glob
| ) |  |

## § EntityPick()

Entity* EntityPick | ( | Entity * | ent,
|  | float | range
| ) |  |

## § EntityPickMode()

void EntityPickMode | ( | Entity * | ent,
|  | int | pick_mode,
|  | bool | obscurer
| ) |  |

## § EntityPitch()

float EntityPitch | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityRadius()

void EntityRadius | ( | Entity * | ent,
|  | float | radius_x,
|  | float | radius_y
| ) |  |

## § EntityRoll()

float EntityRoll | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityScaleX()

float EntityScaleX | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityScaleY()

float EntityScaleY | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityScaleZ()

float EntityScaleZ | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityShininess()

void EntityShininess | ( | Entity * | ent,
|  | float | shine
| ) |  |

## § EntityTexture()

void EntityTexture | ( | Entity * | ent,
|  | Texture * | tex,
|  | int | frame,
|  | int | index
| ) |  |

## § EntityType()

void EntityType | ( | Entity * | ent,
|  | int | type_no,
|  | bool | recursive
| ) |  |

## § EntityVisible()

int EntityVisible | ( | Entity * | src_ent,
|  | Entity * | dest_ent
| ) |  |

## § EntityX()

float EntityX | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityY()

float EntityY | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityYaw()

float EntityYaw | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § EntityZ()

float EntityZ | ( | Entity * | ent,
|  | bool | glob
| ) |  |

## § ExtractAnimSeq()

int ExtractAnimSeq | ( | Entity * | ent,
|  | int | first_frame,
|  | int | last_frame,
|  | int | seq
| ) |  |

## § FindChild()

Entity* FindChild | ( | Entity * | ent,
|  | char * | child_name
| ) |  |

## § FindSurface()

Surface* FindSurface | ( | Mesh * | mesh,
|  | Brush * | brush
| ) |  |

## § FitMesh()

void FitMesh | ( | Mesh * | mesh,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | width,
|  | float | height,
|  | float | depth,
|  | bool | uniform
| ) |  |

## § FlipMesh()

void FlipMesh | ( | Mesh * | mesh | ) |

## § FluidArray()

void FluidArray | ( | Fluid * | fluid,
|  | float * | Array,
|  | int | w,
|  | int | h,
|  | int | d
| ) |  |

## § FluidFunction()

void FluidFunction | ( | Fluid * | fluid,
|  | float(*)(float, float, float) | FieldFunction
| ) |  |

## § FluidThreshold()

void FluidThreshold | ( | Fluid * | fluid,
|  | float | threshold
| ) |  |

## § FreeAction()

void FreeAction | ( | Action * | act | ) |

## § FreeBrush()

void FreeBrush | ( | Brush * | brush | ) |

## § FreeConstraint()

void FreeConstraint | ( | Constraint * | con | ) |

## § FreeEntity()

void FreeEntity | ( | Entity * | ent | ) |

## § FreeRigidBody()

void FreeRigidBody | ( | RigidBody * | body | ) |

## § FreeShader()

void FreeShader | ( | Shader * | shader | ) |

## § FreeShadow()

void FreeShadow | ( | ShadowObject * | shad | ) |

## § FreeStencil()

void FreeStencil | ( | Stencil * | stencil | ) |

## § FreeSurface()

void FreeSurface | ( | Surface * | surf | ) |

## § FreeTexture()

void FreeTexture | ( | Texture * | tex | ) |

## § GeosphereHeight()

void GeosphereHeight | ( | Geosphere * | geo,
|  | float | h
| ) |  |

## § GetBrushTexture()

Texture* GetBrushTexture | ( | Brush * | brush,
|  | int | index
| ) |  |

## § GetChild()

Entity* GetChild | ( | Entity * | ent,
|  | int | child_no
| ) |  |

## § GetEntityBrush()

Brush* GetEntityBrush | ( | Entity * | ent | ) |

## § GetEntityType()

int GetEntityType | ( | Entity * | ent | ) |

## § GetMatElement()

float GetMatElement | ( | Entity * | ent,
|  | int | row,
|  | int | col
| ) |  |

## § GetParentEntity()

Entity* GetParentEntity | ( | Entity * | ent | ) |

## § GetSurface()

Surface* GetSurface | ( | Mesh * | mesh,
|  | int | surf_no
| ) |  |

## § GetSurfaceBrush()

Brush* GetSurfaceBrush | ( | Surface * | surf | ) |

## § Graphics3D()

void Graphics3D | ( | int | width,
|  | int | height,
|  | int | depth,
|  | int | mode,
|  | int | rate
| ) |  |

## § HandleSprite()

void HandleSprite | ( | Sprite * | sprite,
|  | float | h_x,
|  | float | h_y
| ) |  |

## § HideEntity()

void HideEntity | ( | Entity * | ent | ) |

## § LightColor()

void LightColor | ( | Light * | light,
|  | float | red,
|  | float | green,
|  | float | blue
| ) |  |

## § LightConeAngles()

void LightConeAngles | ( | Light * | light,
|  | float | inner_ang,
|  | float | outer_ang
| ) |  |

## § LightRange()

void LightRange | ( | Light * | light,
|  | float | range
| ) |  |

## § LinePick()

Entity* LinePick | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | dx,
|  | float | dy,
|  | float | dz,
|  | float | radius
| ) |  |

## § LoadAnimMesh()

Mesh* LoadAnimMesh | ( | char * | file,
|  | Entity * | parent
| ) |  |

## § LoadAnimSeq()

int LoadAnimSeq | ( | Entity * | ent,
|  | char * | file
| ) |  |

## § LoadAnimTexture()

Texture* LoadAnimTexture | ( | char * | file,
|  | int | flags,
|  | int | frame_width,
|  | int | frame_height,
|  | int | first_frame,
|  | int | frame_count
| ) |  |

## § LoadBrush()

Brush* LoadBrush | ( | char * | file,
|  | int | flags,
|  | float | u_scale,
|  | float | v_scale
| ) |  |

## § LoadGeosphere()

Terrain* LoadGeosphere | ( | char * | file,
|  | Entity * | parent
| ) |  |

## § LoadMaterial()

Material* LoadMaterial | ( | char * | filename,
|  | int | flags,
|  | int | frame_width,
|  | int | frame_height,
|  | int | first_frame,
|  | int | frame_count
| ) |  |

## § LoadMesh()

Mesh* LoadMesh | ( | char * | file,
|  | Entity * | parent
| ) |  |

## § LoadShader()

Shader* LoadShader | ( | char * | ShaderName,
|  | char * | VshaderFileName,
|  | char * | FshaderFileName
| ) |  |

## § LoadSprite()

Sprite* LoadSprite | ( | char * | tex_file,
|  | int | tex_flag,
|  | Entity * | parent
| ) |  |

## § LoadTerrain()

Terrain* LoadTerrain | ( | char * | file,
|  | Entity * | parent
| ) |  |

## § LoadTexture()

Texture* LoadTexture | ( | char * | file,
|  | int | flags
| ) |  |

## § MeshCSG()

Mesh* MeshCSG | ( | Mesh * | m1,
|  | Mesh * | m2,
|  | int | method = `1`
| ) |  |

## § MeshCullRadius()

void MeshCullRadius | ( | Entity * | ent,
|  | float | radius
| ) |  |

## § MeshDepth()

float MeshDepth | ( | Mesh * | mesh | ) |

## § MeshesIntersect()

int MeshesIntersect | ( | Mesh * | mesh1,
|  | Mesh * | mesh2
| ) |  |

## § MeshHeight()

float MeshHeight | ( | Mesh * | mesh | ) |

## § MeshWidth()

float MeshWidth | ( | Mesh * | mesh | ) |

## § ModifyGeosphere()

void ModifyGeosphere | ( | Geosphere * | geo,
|  | int | x,
|  | int | z,
|  | float | new_height
| ) |  |

## § ModifyTerrain()

void ModifyTerrain | ( | Terrain * | terr,
|  | int | x,
|  | int | z,
|  | float | new_height
| ) |  |

## § MoveEntity()

void MoveEntity | ( | Entity * | ent,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § NameEntity()

void NameEntity | ( | Entity * | ent,
|  | char * | name
| ) |  |

## § OctreeBlock()

void OctreeBlock | ( | OcTree * | octree,
|  | Mesh * | mesh,
|  | int | level,
|  | float | X,
|  | float | Y,
|  | float | Z,
|  | float | Near = `0.0`,
|  | float | Far = `1000.0`
| ) |  |

## § OctreeMesh()

void OctreeMesh | ( | OcTree * | octree,
|  | Mesh * | mesh,
|  | int | level,
|  | float | X,
|  | float | Y,
|  | float | Z,
|  | float | Near = `0.0`,
|  | float | Far = `1000.0`
| ) |  |

## § PaintEntity()

void PaintEntity | ( | Entity * | ent,
|  | Brush * | brush
| ) |  |

## § PaintMesh()

void PaintMesh | ( | Mesh * | mesh,
|  | Brush * | brush
| ) |  |

## § PaintSurface()

void PaintSurface | ( | Surface * | surf,
|  | Brush * | brush
| ) |  |

## § ParticleColor()

void ParticleColor | ( | Sprite * | sprite,
|  | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |

## § ParticleTrail()

void ParticleTrail | ( | Sprite * | sprite,
|  | int | length
| ) |  |

## § ParticleVector()

void ParticleVector | ( | Sprite * | sprite,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § PickedEntity()

Entity* PickedEntity | ( |  | ) |

## § PickedNX()

float PickedNX | ( |  | ) |

## § PickedNY()

float PickedNY | ( |  | ) |

## § PickedNZ()

float PickedNZ | ( |  | ) |

## § PickedSurface()

Surface* PickedSurface | ( |  | ) |

## § PickedTime()

float PickedTime | ( |  | ) |

## § PickedTriangle()

int PickedTriangle | ( |  | ) |

## § PickedX()

float PickedX | ( |  | ) |

## § PickedY()

float PickedY | ( |  | ) |

## § PickedZ()

float PickedZ | ( |  | ) |

## § PointEntity()

void PointEntity | ( | Entity * | ent,
|  | Entity * | target_ent,
|  | float | roll
| ) |  |

## § PositionEntity()

void PositionEntity | ( | Entity * | ent,
|  | float | x,
|  | float | y,
|  | float | z,
|  | bool | glob
| ) |  |

## § PositionMesh()

void PositionMesh | ( | Mesh * | mesh,
|  | float | px,
|  | float | py,
|  | float | pz
| ) |  |

## § PositionTexture()

void PositionTexture | ( | Texture * | tex,
|  | float | u_pos,
|  | float | v_pos
| ) |  |

## § ProjectedX()

float ProjectedX | ( |  | ) |

## § ProjectedY()

float ProjectedY | ( |  | ) |

## § ProjectedZ()

float ProjectedZ | ( |  | ) |

## § RenderWorld()

void RenderWorld | ( |  | ) |

## § RepeatMesh()

Mesh* RepeatMesh | ( | Mesh * | mesh,
|  | Entity * | parent
| ) |  |

## § ResetEntity()

void ResetEntity | ( | Entity * | ent | ) |

## § ResetShadow()

void ResetShadow | ( | ShadowObject * | shad | ) |

## § RotateEntity()

void RotateEntity | ( | Entity * | ent,
|  | float | x,
|  | float | y,
|  | float | z,
|  | bool | glob
| ) |  |

## § RotateMesh()

void RotateMesh | ( | Mesh * | mesh,
|  | float | pitch,
|  | float | yaw,
|  | float | roll
| ) |  |

## § RotateSprite()

void RotateSprite | ( | Sprite * | sprite,
|  | float | ang
| ) |  |

## § RotateTexture()

void RotateTexture | ( | Texture * | tex,
|  | float | ang
| ) |  |

## § ScaleEntity()

void ScaleEntity | ( | Entity * | ent,
|  | float | x,
|  | float | y,
|  | float | z,
|  | bool | glob
| ) |  |

## § ScaleMesh()

void ScaleMesh | ( | Mesh * | mesh,
|  | float | sx,
|  | float | sy,
|  | float | sz
| ) |  |

## § ScaleSprite()

void ScaleSprite | ( | Sprite * | sprite,
|  | float | s_x,
|  | float | s_y
| ) |  |

## § ScaleTexture()

void ScaleTexture | ( | Texture * | tex,
|  | float | u_scale,
|  | float | v_scale
| ) |  |

## § SetAnimKey()

void SetAnimKey | ( | Entity * | ent,
|  | float | frame,
|  | int | pos_key = `true`,
|  | int | rot_key = `true`,
|  | int | scale_key = `true`
| ) |  |

## § SetAnimTime()

void SetAnimTime | ( | Entity * | ent,
|  | float | time,
|  | int | seq
| ) |  |

## § SetCubeFace()

void SetCubeFace | ( | Texture * | tex,
|  | int | face
| ) |  |

## § SetCubeMode()

void SetCubeMode | ( | Texture * | tex,
|  | int | mode
| ) |  |

## § SetFloat()

void SetFloat | ( | Shader * | material,
|  | char * | name,
|  | float | v1
| ) |  |

## § SetFloat2()

void SetFloat2 | ( | Shader * | material,
|  | char * | name,
|  | float | v1,
|  | float | v2
| ) |  |

## § SetFloat3()

void SetFloat3 | ( | Shader * | material,
|  | char * | name,
|  | float | v1,
|  | float | v2,
|  | float | v3
| ) |  |

## § SetFloat4()

void SetFloat4 | ( | Shader * | material,
|  | char * | name,
|  | float | v1,
|  | float | v2,
|  | float | v3,
|  | float | v4
| ) |  |

## § SetInteger()

void SetInteger | ( | Shader * | material,
|  | char * | name,
|  | int | v1
| ) |  |

## § SetInteger2()

void SetInteger2 | ( | Shader * | material,
|  | char * | name,
|  | int | v1,
|  | int | v2
| ) |  |

## § SetInteger3()

void SetInteger3 | ( | Shader * | material,
|  | char * | name,
|  | int | v1,
|  | int | v2,
|  | int | v3
| ) |  |

## § SetInteger4()

void SetInteger4 | ( | Shader * | material,
|  | char * | name,
|  | int | v1,
|  | int | v2,
|  | int | v3,
|  | int | v4
| ) |  |

## § ShadeEntity()

void ShadeEntity | ( | Entity * | ent,
|  | Shader * | material
| ) |  |

## § ShadeMesh()

void ShadeMesh | ( | Mesh * | mesh,
|  | Shader * | material
| ) |  |

## § ShaderMaterial()

void ShaderMaterial | ( | Shader * | material,
|  | Material * | tex,
|  | char * | name,
|  | int | index
| ) |  |

## § ShaderTexture()

Texture* ShaderTexture | ( | Shader * | material,
|  | Texture * | tex,
|  | char * | name,
|  | int | index
| ) |  |

## § ShadeSurface()

void ShadeSurface | ( | Surface * | surf,
|  | Shader * | material
| ) |  |

## § ShowEntity()

void ShowEntity | ( | Entity * | ent | ) |

## § SkinMesh()

void SkinMesh | ( | Mesh * | mesh,
|  | int | surf_no_get,
|  | int | vid,
|  | int | bone1,
|  | float | weight1 = `1.0`,
|  | int | bone2 = `0`,
|  | float | weight2 = `0`,
|  | int | bone3 = `0`,
|  | float | weight3 = `0`,
|  | int | bone4 = `0`,
|  | float | weight4 = `0`
| ) |  |

## § SpriteRenderMode()

void SpriteRenderMode | ( | Sprite * | sprite,
|  | int | mode
| ) |  |

## § SpriteViewMode()

void SpriteViewMode | ( | Sprite * | sprite,
|  | int | mode
| ) |  |

## § StencilAlpha()

void StencilAlpha | ( | Stencil * | stencil,
|  | float | a
| ) |  |

## § StencilClsColor()

void StencilClsColor | ( | Stencil * | stencil,
|  | float | r,
|  | float | g,
|  | float | b
| ) |  |

## § StencilClsMode()

void StencilClsMode | ( | Stencil * | stencil,
|  | int | cls_depth,
|  | int | cls_zbuffer
| ) |  |

## § StencilMesh()

void StencilMesh | ( | Stencil * | stencil,
|  | Mesh * | mesh,
|  | int | mode = `1`
| ) |  |

## § StencilMode()

void StencilMode | ( | Stencil * | stencil,
|  | int | m,
|  | int | o = `1`
| ) |  |

## § TerrainHeight()

float TerrainHeight | ( | Terrain * | terr,
|  | int | x,
|  | int | z
| ) |  |

## § TerrainX()

float TerrainX | ( | Terrain * | terr,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § TerrainY()

float TerrainY | ( | Terrain * | terr,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § TerrainZ()

float TerrainZ | ( | Terrain * | terr,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § TexToBuffer()

void TexToBuffer | ( | Texture * | tex,
|  | unsigned char * | buffer,
|  | int | frame
| ) |  |

## § TextureBlend()

void TextureBlend | ( | Texture * | tex,
|  | int | blend
| ) |  |

## § TextureCoords()

void TextureCoords | ( | Texture * | tex,
|  | int | coords
| ) |  |

## § TextureFilter()

void TextureFilter | ( | char * | match_text,
|  | int | flags
| ) |  |

## § TextureFlags()

void TextureFlags | ( | Texture * | tex,
|  | int | flags
| ) |  |

## § TextureGLTexEnv()

void TextureGLTexEnv | ( | Texture * | tex,
|  | int | target,
|  | int | pname,
|  | int | param
| ) |  |

## § TextureHeight()

int TextureHeight | ( | Texture * | tex | ) |

## § TextureName()

const char* TextureName | ( | Texture * | tex | ) |

## § TextureWidth()

int TextureWidth | ( | Texture * | tex | ) |

## § TFormedX()

float TFormedX | ( |  | ) |

## § TFormedY()

float TFormedY | ( |  | ) |

## § TFormedZ()

float TFormedZ | ( |  | ) |

## § TFormNormal()

void TFormNormal | ( | float | x,
|  | float | y,
|  | float | z,
|  | Entity * | src_ent,
|  | Entity * | dest_ent
| ) |  |

## § TFormPoint()

void TFormPoint | ( | float | x,
|  | float | y,
|  | float | z,
|  | Entity * | src_ent,
|  | Entity * | dest_ent
| ) |  |

## § TFormVector()

void TFormVector | ( | float | x,
|  | float | y,
|  | float | z,
|  | Entity * | src_ent,
|  | Entity * | dest_ent
| ) |  |

## § TranslateEntity()

void TranslateEntity | ( | Entity * | ent,
|  | float | x,
|  | float | y,
|  | float | z,
|  | bool | glob
| ) |  |

## § TriangleVertex()

int TriangleVertex | ( | Surface * | surf,
|  | int | tri_no,
|  | int | corner
| ) |  |

## § TurnEntity()

void TurnEntity | ( | Entity * | ent,
|  | float | x,
|  | float | y,
|  | float | z,
|  | bool | glob
| ) |  |

## § UpdateNormals()

void UpdateNormals | ( | Mesh * | mesh | ) |

## § UpdateTexCoords()

void UpdateTexCoords | ( | Surface * | surf | ) |

## § UpdateWorld()

void UpdateWorld | ( | float | anim_speed | ) |

## § UseFloat()

void UseFloat | ( | Shader * | material,
|  | char * | name,
|  | float * | v1
| ) |  |

## § UseFloat2()

void UseFloat2 | ( | Shader * | material,
|  | char * | name,
|  | float * | v1,
|  | float * | v2
| ) |  |

## § UseFloat3()

void UseFloat3 | ( | Shader * | material,
|  | char * | name,
|  | float * | v1,
|  | float * | v2,
|  | float * | v3
| ) |  |

## § UseFloat4()

void UseFloat4 | ( | Shader * | material,
|  | char * | name,
|  | float * | v1,
|  | float * | v2,
|  | float * | v3,
|  | float * | v4
| ) |  |

## § UseInteger()

void UseInteger | ( | Shader * | material,
|  | char * | name,
|  | int * | v1
| ) |  |

## § UseInteger2()

void UseInteger2 | ( | Shader * | material,
|  | char * | name,
|  | int * | v1,
|  | int * | v2
| ) |  |

## § UseInteger3()

void UseInteger3 | ( | Shader * | material,
|  | char * | name,
|  | int * | v1,
|  | int * | v2,
|  | int * | v3
| ) |  |

## § UseInteger4()

void UseInteger4 | ( | Shader * | material,
|  | char * | name,
|  | int * | v1,
|  | int * | v2,
|  | int * | v3,
|  | int * | v4
| ) |  |

## § UseMatrix()

void UseMatrix | ( | Shader * | material,
|  | char * | name,
|  | int | mode
| ) |  |

## § UseStencil()

void UseStencil | ( | Stencil * | stencil | ) |

## § UseSurface()

void UseSurface | ( | Shader * | material,
|  | char * | name,
|  | Surface * | surf,
|  | int | vbo
| ) |  |

## § VectorPitch()

float VectorPitch | ( | float | vx,
|  | float | vy,
|  | float | vz
| ) |  |

## § VectorYaw()

float VectorYaw | ( | float | vx,
|  | float | vy,
|  | float | vz
| ) |  |

## § VertexAlpha()

float VertexAlpha | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexBlue()

float VertexBlue | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexColor()

void VertexColor | ( | Surface * | surf,
|  | int | vid,
|  | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) |  |

## § VertexCoords()

void VertexCoords | ( | Surface * | surf,
|  | int | vid,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

## § VertexGreen()

float VertexGreen | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexNormal()

void VertexNormal | ( | Surface * | surf,
|  | int | vid,
|  | float | nx,
|  | float | ny,
|  | float | nz
| ) |  |

## § VertexNX()

float VertexNX | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexNY()

float VertexNY | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexNZ()

float VertexNZ | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexRed()

float VertexRed | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexTexCoords()

void VertexTexCoords | ( | Surface * | surf,
|  | int | vid,
|  | float | u,
|  | float | v,
|  | float | w,
|  | int | coord_set
| ) |  |

## § VertexU()

float VertexU | ( | Surface * | surf,
|  | int | vid,
|  | int | coord_set
| ) |  |

## § VertexV()

float VertexV | ( | Surface * | surf,
|  | int | vid,
|  | int | coord_set
| ) |  |

## § VertexW()

float VertexW | ( | Surface * | surf,
|  | int | vid,
|  | int | coord_set
| ) |  |

## § VertexX()

float VertexX | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexY()

float VertexY | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VertexZ()

float VertexZ | ( | Surface * | surf,
|  | int | vid
| ) |  |

## § VoxelSpriteMaterial()

void VoxelSpriteMaterial | ( | VoxelSprite * | voxelspr,
|  | Material * | mat
| ) |  |

## § Wireframe()

void Wireframe | ( | int | enable | ) |